#include <stdio.h>
#include <string.h>
#include <math.h>

/*calculates linear regression of a data set: y=a+b*x*/

int main(int argc,char**argv)
{
  FILE* fr1;
  FILE* fw1;
  int j;
  double i,k0,k1,n,k2,k3;
  double t,dvdl,av_x,av_y,a,b,r;
  double sum_x,sum_y,sum_xy,sum_x2,sum_x3;
  double sum_x4,sum_x5,sum_x6,sum_x2y,sum_x3y;
  double s_x,s_y,s_xy;
  double detA, detB0, detB1, detB2, detB3;
  char buff[200],name[200];
  i=0.0,j=0;
  sum_x=0;sum_y=0;sum_xy=0;sum_x2=0;sum_x3=0;
  sum_x4=0;sum_x5=0;sum_x6=0;sum_x2y=0;sum_x3y=0;
  s_x=0;s_y=0;s_xy=0;
  
  if(argc != 3){
    printf("Usage: %s <filename1> <output_file>\n",argv[0]);
    exit(1);
  }

  fr1=fopen(argv[1],"r");
  if (! (fr1) ){
    printf("File %s does not exists!\n",argv[1]);
    exit(1);
  }

  fw1=fopen(argv[2],"a");


  while(fgets(buff,sizeof(buff),fr1)) {
     sscanf(buff,"%lf %lf",&t,&dvdl);     
     //printf("%f %f\n",t,dvdl);
     sum_x=sum_x+t;
     sum_x2=sum_x2+t*t;
     sum_x3=sum_x3+t*t*t;
     sum_x4=sum_x4+t*t*t*t;
     sum_x5=sum_x5+t*t*t*t*t;
     sum_x6=sum_x6+t*t*t*t*t*t;
     sum_y=sum_y+dvdl;
     sum_xy=sum_xy+t*dvdl;
     sum_x2y=sum_x2y+t*t*dvdl;
     sum_x3y=sum_x3y+t*t*t*dvdl;
     i=i+1.0;
  }
  n=i;
  av_x=sum_x/i;
  av_y=sum_y/i;
  printf("i = %lf\n",i);
  printf("Average x(time) = %.9lf\n",av_x);
  printf("Average y(dvdl) = %.9lf\n",av_y);
  //printf("sum_x = %.9lf\n",sum_x);
  //printf("sum_y = %.9lf\n",sum_y);
  //printf("sum_x2 = %.9lf\n",sum_x2);
  //printf("sum_x3 = %.9lf\n",sum_x3);
  //printf("sum_x4 = %.9lf\n",sum_x4);
  //printf("sum_x5 = %.9lf\n",sum_x5);
  //printf("sum_x6 = %.9lf\n",sum_x6);
  //printf("sum_xy = %.9lf\n",sum_xy);
  //printf("sum_x2y = %.9lf\n",sum_x2y);
  //printf("sum_x3y = %.9lf\n",sum_x3y);

  rewind(fr1);

  /* q is Sum (y[j]-k0-k1*x[j]-k2*x[j]^2-k3*x[j]^3)^2 for j between 1 and n data*/
  /* from der_q_k0 */
  /* -2(-k0*n-k1*av_x*n-k2*sum_x2-k3*sum_x3+av_y*n)=0 */

  /*n*k0+k1*av_x*n+k2*sum_x2+k3*sum_x3=av_y*n;*/
  
  /*from der_q_k1 */
  /* -2*av_x*n(-k0-k1*av_x*n-k2*sum_x2-k3*sum_x3+av_y*n)=0 */
  /* -2*(-k0*av_x*n-k1*sum_x2-k2*sum_x3-k3*sum_x4+sum_xj)=0 */

  /* k0*av_x*n+k1*sum_x2+k2*sum_x3+k3*sum_x4=sum_xy; */

  /* from der_q_k2 */
  /* -2*sum_x2*(-k0-k1*av_x*n-k2*sum_x2-k3*sum_x3+av_j*n)=0 */
  /* -2*(-k0*sum_x2-k1*sum_x3-k2*sum_x4-k3*sum_x5+sum_x2j)=0 */
   
  /* k0*sum_x2+k1*sum_x3+k2*sum_x4+k3*sum_x5=sum_x2j; */

  /* from der_q_k3 */

  /* k0*sum_x3+k1*sum_x4+k2*sum_x5+k3*sum_x6=sum_x3j; */

  /* Matrix A is:
   n       sum_x   sum_x2   sum_x3 
   sum_x   sum_x2  sum_x3   sum_x4    
   sum_x2  sum_x3  sum_x4   sum_x5
   sum_x3  sum_x4  sum_x5   sum_x6   */

  detA=(pow(sum_x3,4)) - 3*sum_x2*(pow(sum_x3,2))*sum_x4 + (pow(sum_x2,2))*(pow(sum_x4,2)) + 
    2*sum_x*sum_x3*(pow(sum_x4,2)) - n*(pow(sum_x4,3)) + 
    2*(pow(sum_x2,2))*sum_x3*sum_x5 - 2*sum_x*(pow(sum_x3,2))*sum_x5 - 
    2*sum_x*sum_x2*sum_x4*sum_x5 + 2*n*sum_x3*sum_x4*sum_x5 + 
    (pow(sum_x,2))*(pow(sum_x5,2)) - n*sum_x2*(pow(sum_x5,2)) - (pow(sum_x2,3))*sum_x6 + 
    2*sum_x*sum_x2*sum_x3*sum_x6 - n*(pow(sum_x3,2))*sum_x6 - 
    (pow(sum_x,2))*sum_x4*sum_x6 + n*sum_x2*sum_x4*sum_x6;
  
  /* Matrix B0 is:
   sum_y   sum_x   sum_x2   sum_x3 
   sum_xy  sum_x2  sum_x3   sum_x4    
   sum_x2y sum_x3  sum_x4   sum_x5
   sum_x3y sum_x4  sum_x5   sum_x6   */
   
    detB0=(pow(sum_x3,3))*sum_x3y - sum_x2y*(pow(sum_x3,2))*sum_x4 - 
    2*sum_x2*sum_x3*sum_x3y*sum_x4 + sum_x2*sum_x2y*(pow(sum_x4,2)) + 
    sum_x*sum_x3y*(pow(sum_x4,2)) + sum_x2*sum_x2y*sum_x3*sum_x5 + 
    (pow(sum_x2,2))*sum_x3y*sum_x5 - sum_x*sum_x3*sum_x3y*sum_x5 - 
    sum_x*sum_x2y*sum_x4*sum_x5 - (pow(sum_x2,2))*sum_x2y*sum_x6 + 
    sum_x*sum_x2y*sum_x3*sum_x6 + sum_x3*(pow(sum_x4,2))*sum_xy - 
    (pow(sum_x3,2))*sum_x5*sum_xy - sum_x2*sum_x4*sum_x5*sum_xy + 
    sum_x*(pow(sum_x5,2))*sum_xy + sum_x2*sum_x3*sum_x6*sum_xy - 
    sum_x*sum_x4*sum_x6*sum_xy - (pow(sum_x4,3))*sum_y + 
    2*sum_x3*sum_x4*sum_x5*sum_y - sum_x2*(pow(sum_x5,2))*sum_y - 
    (pow(sum_x3,2))*sum_x6*sum_y + sum_x2*sum_x4*sum_x6*sum_y;

  /* Matrix B1 is:
   n,       sum_y,    sum_x2,   sum_x3 
   sum_x,   sum_xy,   sum_x3,   sum_x4    
   sum_x2,  sum_x2y,  sum_x4,   sum_x5
   sum_x3,  sum_x3y,  sum_x5,   sum_x6   */

 detB1=sum_x2y*(pow(sum_x3,3)) - sum_x2*(pow(sum_x3,2))*sum_x3y - 
   sum_x2*sum_x2y*sum_x3*sum_x4 + (pow(sum_x2,2))*sum_x3y*sum_x4 + 
   sum_x*sum_x3*sum_x3y*sum_x4 - n*sum_x3y*(pow(sum_x4,2)) - 
    sum_x*sum_x2y*sum_x3*sum_x5 - sum_x*sum_x2*sum_x3y*sum_x5 + 
    n*sum_x3*sum_x3y*sum_x5 + n*sum_x2y*sum_x4*sum_x5 + 
    sum_x*sum_x2*sum_x2y*sum_x6 - n*sum_x2y*sum_x3*sum_x6 - 
   (pow(sum_x3,2))*sum_x4*sum_xy + 2*sum_x2*sum_x3*sum_x5*sum_xy - 
   n*(pow(sum_x5,2))*sum_xy - (pow(sum_x2,2))*sum_x6*sum_xy + 
   n*sum_x4*sum_x6*sum_xy + sum_x3*(pow(sum_x4,2))*sum_y - 
   (pow(sum_x3,2))*sum_x5*sum_y - sum_x2*sum_x4*sum_x5*sum_y + 
   sum_x*(pow(sum_x5,2))*sum_y + sum_x2*sum_x3*sum_x6*sum_y - 
   sum_x*sum_x4*sum_x6*sum_y;

  /* Matrix B2 is:
   n,       sum_x,   sum_y,      sum_x3 
   sum_x,   sum_x2,  sum_xy,     sum_x4    
   sum_x2,  sum_x3,  sum_x2y,    sum_x5
   sum_x3,  sum_x4,  sum_x3y,    sum_x6   */

detB2=-sum_x2*sum_x2y*(pow(sum_x3,2)) + (pow(sum_x2,2))*sum_x3*sum_x3y - 
  sum_x*(pow(sum_x3,2))*sum_x3y + 2*sum_x*sum_x2y*sum_x3*sum_x4 - 
    sum_x*sum_x2*sum_x3y*sum_x4 + n*sum_x3*sum_x3y*sum_x4 - 
  n*sum_x2y*(pow(sum_x4,2)) + (pow(sum_x,2))*sum_x3y*sum_x5 - 
  n*sum_x2*sum_x3y*sum_x5 - (pow(sum_x,2))*sum_x2y*sum_x6 + 
  n*sum_x2*sum_x2y*sum_x6 + (pow(sum_x3,3))*sum_xy - 
    sum_x2*sum_x3*sum_x4*sum_xy - sum_x*sum_x3*sum_x5*sum_xy + 
    n*sum_x4*sum_x5*sum_xy + sum_x*sum_x2*sum_x6*sum_xy - 
  n*sum_x3*sum_x6*sum_xy - (pow(sum_x3,2))*sum_x4*sum_y + 
  sum_x2*(pow(sum_x4,2))*sum_y + sum_x2*sum_x3*sum_x5*sum_y - 
  sum_x*sum_x4*sum_x5*sum_y - (pow(sum_x2,2))*sum_x6*sum_y + 
  sum_x*sum_x3*sum_x6*sum_y;
		           
  /* Matrix B3 is:
   n,       sum_x,   sum_x2,   sum_y   
   sum_x,   sum_x2,  sum_x3,   sum_xy     
   sum_x2,  sum_x3,  sum_x4,   sum_x2y
   sum_x3,  sum_x4,  sum_x5,   sum_x3y   */

detB3=(pow(sum_x2,2))*sum_x2y*sum_x3 - sum_x*sum_x2y*(pow(sum_x3,2)) - 
  (pow(sum_x2,3))*sum_x3y + 2*sum_x*sum_x2*sum_x3*sum_x3y - 
  n*(pow(sum_x3,2))*sum_x3y - sum_x*sum_x2*sum_x2y*sum_x4 + 
  n*sum_x2y*sum_x3*sum_x4 - (pow(sum_x,2))*sum_x3y*sum_x4 + 
  n*sum_x2*sum_x3y*sum_x4 + (pow(sum_x,2))*sum_x2y*sum_x5 - 
  n*sum_x2*sum_x2y*sum_x5 - sum_x2*(pow(sum_x3,2))*sum_xy + 
  (pow(sum_x2,2))*sum_x4*sum_xy + sum_x*sum_x3*sum_x4*sum_xy - 
  n*(pow(sum_x4,2))*sum_xy - sum_x*sum_x2*sum_x5*sum_xy + 
  n*sum_x3*sum_x5*sum_xy + (pow(sum_x3,3))*sum_y - 
  2*sum_x2*sum_x3*sum_x4*sum_y + sum_x*(pow(sum_x4,2))*sum_y +
  (pow(sum_x2,2))*sum_x5*sum_y - sum_x*sum_x3*sum_x5*sum_y;


  k0=detB0/detA;
  k1=detB1/detA;
  k2=detB2/detA;
  k3=detB3/detA;

  printf("Cubic fit: y = %.9lf + %.9lf*x + %.9lf*x^2 + %.9lf*x^3\n",k0,k1,k2,k3);
  fprintf (fw1,"%.9lf %.9lf %.9lf %.9lf\n",k0,k1,k2,k3);

  fclose(fr1);
  fclose(fw1);

  return 0;
}
