#!/bin/tcsh 

#csh -f 
# run_ti > & ! ti.log &

setenv mol system
setenv dir `pwd`
setenv gmx /home/sdonnin/GROMACS/gmx-3.3.3/bin

set np = 1

set top_dir = ${dir}
set reg_dir = /home/sdonnin/l-dynamics/HIS/HIS-2l-water/Param_dvdl
set start=eq.gro

set time_fep=1000

foreach l (0.0 0.1 0.2 0.3 0.4 0.5 0.6 0.7 0.8 0.9 1.0)

cd lambda_$l

#converti ascissa da tempo a lambda
awk '{ if ($1!~/#/ && $1!~/@/) {print $1/1000, $2} }' dgdl.xvg > dgdl_noh_l.xvg
 
${reg_dir}/regression dgdl_noh_l.xvg ${dir}/regression.out

echo $l >> ${dir}/x.dat

cd ../

end

paste x.dat regression.out > temp

awk '{print $1,$2}' temp > a.dat
awk '{print $1,$3}' temp > b.dat
awk '{print $1,$4}' temp > c.dat
awk '{print $1,$5}' temp > d.dat
rm -rf temp

${reg_dir}/regression a.dat ${dir}/regression_a.out 
${reg_dir}/regression b.dat ${dir}/regression_b.out
${reg_dir}/regression c.dat ${dir}/regression_c.out 
${reg_dir}/regression d.dat ${dir}/regression_d.out


foreach p (a b c d)

set ${p}1=`awk '{print $1}' regression_${p}.out`
set ${p}2=`awk '{print $2}' regression_${p}.out`
set ${p}3=`awk '{print $3}' regression_${p}.out`
set ${p}4=`awk '{print $4}' regression_${p}.out`

end


echo y= a + b"*"l1 +c"*"l1^2 + d"*"l1^3

foreach p (a b c d)

echo ${p}= ${p}1 + ${p}2"*"l2 + ${p}3"*"l2^2 + ${p}4"*"l2^3

end

echo a= ${a1} ${a2} ${a3} ${a4} >> param.dat 
echo b= ${b1} ${b2} ${b3} ${b4} >> param.dat 
echo c= ${c1} ${c2} ${c3} ${c4} >> param.dat 
echo d= ${d1} ${d2} ${d3} ${d4} >> param.dat 


#rm lambda*/*.dat lambda*/regression.out
#rm x.dat regression_a* regression_b* regression_c* regression_d* a*.dat b*.dat c*.dat d*.dat
